
// ManivelaBielaCorrederaDoc.cpp: implementacin de la clase CManivelaBielaCorrederaDoc
//

#include "stdafx.h"
// Se pueden definir SHARED_HANDLERS en un proyecto ATL implementando controladores de vista previa, miniatura
// y filtro de bsqueda, y permiten compartir cdigo de documentos con ese proyecto.
#ifndef SHARED_HANDLERS
#include "ManivelaBielaCorredera.h"
#endif

#include "ManivelaBielaCorrederaDoc.h"

#include <propkey.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CManivelaBielaCorrederaDoc

IMPLEMENT_DYNCREATE(CManivelaBielaCorrederaDoc, CDocument)

BEGIN_MESSAGE_MAP(CManivelaBielaCorrederaDoc, CDocument)
END_MESSAGE_MAP()


// Construccin o destruccin de CManivelaBielaCorrederaDoc

CManivelaBielaCorrederaDoc::CManivelaBielaCorrederaDoc()
{

	m_DataModel.SetManivelaSize(100.0);			// asigna tamao de Manivela
	m_DataModel.SetManivelaAngle(0.0);			// asigna angulo inicial de la Manivela

	m_DataModel.SetBielaSize(200.0);			// asigna tamao de la biela
	m_DataModel.SetBielaAngle(0.0);				// asigna angulo inicial de la biela

	CFloatPoint Pt(0.0,0.0);
	m_DataModel.SetNodo1(Pt);					// posicion del Nodo 1

	Pt.m_X += m_DataModel.GetManivelaSize();	// calcula posicion del nodo 2
	m_DataModel.SetNodo2(Pt);					// posicion del nodo 2

	Pt.m_X += m_DataModel.GetBielaSize();		// calcula posicion del nodo 3
	m_DataModel.SetNodo3(Pt);					// posicion del nodo 3

	CFloatPoint PtNode3 = m_DataModel.GetNodo3();	// recupera la posicion del nodo 3
	CRect rcCorredera((int)(PtNode3.m_X-30.0),(int)(PtNode3.m_Y+20.0),(int)(PtNode3.m_X+30.0),(int)(PtNode3.m_Y-20.0));
	m_DataModel.SetRectCorredera(rcCorredera);		// asigna rectangulo de la corredera

}

CManivelaBielaCorrederaDoc::~CManivelaBielaCorrederaDoc()
{
}

BOOL CManivelaBielaCorrederaDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: agregar aqu cdigo de reinicio
	// (los documentos SDI volvern a utilizar este documento)

	return TRUE;
}




// Serializacin de CManivelaBielaCorrederaDoc

void CManivelaBielaCorrederaDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: agregar aqu el cdigo de almacenamiento
	}
	else
	{
		// TODO: agregar aqu el cdigo de carga
	}
}

#ifdef SHARED_HANDLERS

// Compatibilidad con miniaturas
void CManivelaBielaCorrederaDoc::OnDrawThumbnail(CDC& dc, LPRECT lprcBounds)
{
	// Modifique este cdigo para dibujar los datos del documento
	dc.FillSolidRect(lprcBounds, RGB(255, 255, 255));

	CString strText = _T("TODO: implement thumbnail drawing here");
	LOGFONT lf;

	CFont* pDefaultGUIFont = CFont::FromHandle((HFONT) GetStockObject(DEFAULT_GUI_FONT));
	pDefaultGUIFont->GetLogFont(&lf);
	lf.lfHeight = 36;

	CFont fontDraw;
	fontDraw.CreateFontIndirect(&lf);

	CFont* pOldFont = dc.SelectObject(&fontDraw);
	dc.DrawText(strText, lprcBounds, DT_CENTER | DT_WORDBREAK);
	dc.SelectObject(pOldFont);
}

// Compatibilidad con controladores de bsqueda
void CManivelaBielaCorrederaDoc::InitializeSearchContent()
{
	CString strSearchContent;
	// Establezca contenido de bsqueda a partir de los datos del documento. 
	// Las partes de contenido deben ir separadas por ";"

	// Por ejemplo:  strSearchContent = _T("point;rectangle;circle;ole object;");
	SetSearchContent(strSearchContent);
}

void CManivelaBielaCorrederaDoc::SetSearchContent(const CString& value)
{
	if (value.IsEmpty())
	{
		RemoveChunk(PKEY_Search_Contents.fmtid, PKEY_Search_Contents.pid);
	}
	else
	{
		CMFCFilterChunkValueImpl *pChunk = NULL;
		ATLTRY(pChunk = new CMFCFilterChunkValueImpl);
		if (pChunk != NULL)
		{
			pChunk->SetTextValue(PKEY_Search_Contents, value, CHUNK_TEXT);
			SetChunkValue(pChunk);
		}
	}
}

#endif // SHARED_HANDLERS

// Diagnsticos de CManivelaBielaCorrederaDoc

#ifdef _DEBUG
void CManivelaBielaCorrederaDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CManivelaBielaCorrederaDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// Comandos de CManivelaBielaCorrederaDoc
