
// ManivelaBielaCorrederaView.cpp: implementacin de la clase CManivelaBielaCorrederaView
//

#include "stdafx.h"
// Se pueden definir SHARED_HANDLERS en un proyecto ATL implementando controladores de vista previa, miniatura
// y filtro de bsqueda, y permiten compartir cdigo de documentos con ese proyecto.

#include "ManivelaBielaCorredera.h"

#include "ManivelaBielaCorrederaDoc.h"
#include "ManivelaBielaCorrederaView.h"

#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CManivelaBielaCorrederaView

IMPLEMENT_DYNCREATE(CManivelaBielaCorrederaView, CView)

BEGIN_MESSAGE_MAP(CManivelaBielaCorrederaView, CView)
		ON_WM_TIMER()
		ON_WM_CREATE()
END_MESSAGE_MAP()

// Construccin o destruccin de CManivelaBielaCorrederaView

CManivelaBielaCorrederaView::CManivelaBielaCorrederaView()
{
	// TODO: agregar aqu el cdigo de construccin
		
	m_nNodeSize = 5;		// radio de un Nodo

}

CManivelaBielaCorrederaView::~CManivelaBielaCorrederaView()
{
}

BOOL CManivelaBielaCorrederaView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: modificar aqu la clase Window o los estilos cambiando
	//  CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// Dibujo de CManivelaBielaCorrederaView

void CManivelaBielaCorrederaView::OnDraw(CDC* pDC)
{
	CManivelaBielaCorrederaDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc) return;

// TODO: agregar aqu el cdigo de dibujo para datos nativos

	SetMapping(pDC);					// invierte las coordenadas

	CDataModel * pDataModel = GetDataModel();
	CFloatPoint PtNode1 = pDataModel->GetNodo1();
	
// Ejes
	CPen AxisPen(PS_DASHDOTDOT,0,RGB(0,0,0));
	CObject* pOldPen = (CGdiObject*)pDC->SelectObject(AxisPen);
	CRect rcCli;
	GetClientRect(rcCli);
	pDC->DPtoLP(rcCli);
	pDC->MoveTo(rcCli.left,0);
	pDC->LineTo(rcCli.right,0);
	pDC->MoveTo(0,rcCli.top);
	pDC->LineTo(0,rcCli.bottom);
	pDC->SelectObject(pOldPen);						// devolver el objeto seleccionado

//tierra
	CBrush HashBrush(HS_BDIAGONAL ,RGB(92,92,92));
	CGdiObject* pOldBrushObj = (CGdiObject*)pDC->SelectObject(HashBrush);

	CRect rcTierraNodo1((int)PtNode1.m_X,(int)PtNode1.m_Y,(int)PtNode1.m_X,(int)PtNode1.m_Y);// base del nodo 1
	rcTierraNodo1.left -= 30;
	rcTierraNodo1.right += 30;
	rcTierraNodo1.bottom -= 20;
	pDC->Rectangle(rcTierraNodo1);

	CRect rcCorredera;
	pDataModel->GetRectCorredera(rcCorredera);			// rectangulo tierra de la corredera
	rcCorredera.left -= 100;
	rcCorredera.right += 100;
	int nHeight = (rcCorredera.top - rcCorredera.bottom);
	rcCorredera.top += nHeight/2;
	rcCorredera.bottom += nHeight;
	pDC->Rectangle(rcCorredera);
	rcCorredera.top -= 2*nHeight;
	rcCorredera.bottom -= nHeight;
	pDC->Rectangle(rcCorredera);	

// Nodo 1 y manivela 
	CBrush GraySolidBrush(RGB(92,92,92));
	pDC->SelectObject(GraySolidBrush);
	CRect rcNode;
	rcNode.SetRect((int)(PtNode1.m_X-5),(int)(PtNode1.m_Y+5),(int)(PtNode1.m_X+5),(int)(PtNode1.m_Y-5));
	pDC->Ellipse(rcNode);
	CFloatPoint PtNode2 = pDataModel->GetNodo2();

	TraceEslabon(pDC, PtNode1,PtNode2);					// traza eslabon con node final ...

	TraceCorredera(pDC);								// corredera
}

/***********************************************************************************************************************/
void CManivelaBielaCorrederaView::SetMapping(CDC * pDC) 
{
	pDC->SetMapMode(MM_ISOTROPIC);
	CRect rcCli;
	GetClientRect(rcCli);
	pDC->SetViewportOrg(0,0);
	pDC->SetViewportExt(rcCli.Width(),rcCli.Height());
	pDC->SetWindowOrg(-rcCli.Width()/2,rcCli.Height()/2);
	pDC->SetWindowExt(rcCli.Width(),-rcCli.Height());
}

/***********************************************************************************************************************/
void CManivelaBielaCorrederaView::TraceEslabon(CDC * pDC, CFloatPoint & PtOrig,CFloatPoint & PtDest) 
{
	CGdiObject* pOldObj = pDC->SelectStockObject(BLACK_PEN); 
	pDC->MoveTo((int)PtOrig.m_X,(int)PtOrig.m_Y);
	pDC->LineTo((int)PtDest.m_X,(int)PtDest.m_Y);
	pDC->Ellipse((int)PtDest.m_X-m_nNodeSize,(int)PtDest.m_Y-m_nNodeSize,(int)PtDest.m_X+m_nNodeSize,(int)PtDest.m_Y+m_nNodeSize);
	pDC->SelectObject(pOldObj); 							// devolver el objeto original
}

/***********************************************************************************************************************/
void CManivelaBielaCorrederaView::TraceCorredera(CDC * pDC) 
{
	CDataModel * pDataModel = GetDataModel();

	CBrush GrayBrush(RGB(92,92,92));
	CGdiObject * pOldObj = (CGdiObject *)pDC->SelectObject(GrayBrush);
	CRect rcCorredera;
	pDataModel->GetRectCorredera(rcCorredera);			// rectangulo de la corredera
	pDC->Rectangle(rcCorredera);
	CPoint PtCenter = rcCorredera.CenterPoint();
	pDC->SelectStockObject(WHITE_BRUSH); 
	pDC->Ellipse(PtCenter.x-m_nNodeSize,PtCenter.y-m_nNodeSize,PtCenter.x+m_nNodeSize,PtCenter.y+m_nNodeSize);
	pDC->SelectObject(pOldObj);							// devolver el objeto original

}

/***********************************************************************************************************************/
void CManivelaBielaCorrederaView::GetRectManivela(CRect & rcManivela) 
{
	CDataModel * pDataModel = GetDataModel();
	CFloatPoint	PtNodo1 = pDataModel->GetNodo1();		// Nodo Tierra-Manivela
	rcManivela.SetRect((int)PtNodo1.m_X-(int)pDataModel->GetManivelaSize(),(int)PtNodo1.m_Y+(int)pDataModel->GetManivelaSize(),
	  				   (int)PtNodo1.m_X+(int)pDataModel->GetManivelaSize(),(int)PtNodo1.m_Y-(int)pDataModel->GetManivelaSize());
}

// Controladores de mensaje de CManivelaBielaCorrederaView
/***********************************************************************************************************************/
CDataModel * CManivelaBielaCorrederaView::GetDataModel() 
{
	CManivelaBielaCorrederaDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc) return NULL;

	return pDoc->GetDataModel();
}	

/***********************************************************************************************************************/

int CManivelaBielaCorrederaView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Agregue aqu su cdigo de creacin especializado
	
	SetTimer(1313,10,NULL);    

	return 0;
}
/***********************************************************************************************************************/
void CManivelaBielaCorrederaView::OnTimer(UINT nIDEvent) 
{
	if ( nIDEvent == 1313 )
	 {
		CDataModel * pDataModel = GetDataModel();

		double dAngle = pDataModel->GetBielaAngle();
		dAngle += 1/57.295;
		pDataModel->SetBielaAngle(dAngle);

		double dX = pDataModel->GetNodo1().m_X + pDataModel->GetManivelaSize()*cos(dAngle);
	    double dY = pDataModel->GetNodo1().m_Y + pDataModel->GetManivelaSize()*sin(dAngle);

		pDataModel->SetNodo2(dX,dY);

		CRect rcManivela;
		GetRectManivela(rcManivela); 
		CDC * pDC = GetDC();
		SetMapping(pDC); 
		pDC->LPtoDP(rcManivela);
		rcManivela.InflateRect(m_nNodeSize,m_nNodeSize);
		ReleaseDC(pDC);

		InvalidateRect(rcManivela);
	 }
}


// Diagnsticos de CManivelaBielaCorrederaView

#ifdef _DEBUG
void CManivelaBielaCorrederaView::AssertValid() const
{
	CView::AssertValid();
}

void CManivelaBielaCorrederaView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CManivelaBielaCorrederaDoc* CManivelaBielaCorrederaView::GetDocument() const // La versin de no depuracin es en lnea
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CManivelaBielaCorrederaDoc)));
	return (CManivelaBielaCorrederaDoc*)m_pDocument;
}
#endif //_DEBUG


// Controladores de mensaje de CManivelaBielaCorrederaView
